'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function () {
  let opts = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];
  const pattern = opts.pattern;
  const lazy = opts.lazy;
  const rename = opts.rename;
  const config = opts.config;

  const defaultPkg = _path2.default.join(process.cwd(), 'package.json');
  const loadOpts = {
    config: config || defaultPkg,
    pattern: pattern || ['gulp-*', 'gulp.*', 'del', 'run-sequence', 'browser-sync'],
    lazy: !!lazy,
    rename: Object.assign({
      'gulp-util': 'gutil',
      'run-sequence': 'sequence',
      'gulp-if': 'gulpIf'
    }, rename)
  };

  return Object.assign({}, (0, _gulpLoadPlugins2.default)(loadOpts));
};

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _gulpLoadPlugins = require('gulp-load-plugins');

var _gulpLoadPlugins2 = _interopRequireDefault(_gulpLoadPlugins);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

module.exports = exports['default'];

/**
 * Load all the Gulp plugins for the `root` package.json and any additonal specified packages
 * @param {Object} opts options
 * @param {String|Array} opts.packages
 * @param {String|Array} opts.pattern
 * @param {Boolean} opts.lazy
 * @param {Object} opts.rename
 * @return {Object} gulp tasks plugins
 *
 */